﻿Imports System
Imports System.Threading
Imports System.Threading.Thread

Delegate Sub AddListCallback(ByVal [text] As String)
Delegate Sub SetStatusCallback(ByVal [text] As String)

Public Class ExtCmdStdout
    Private FormStdout As ExtCmdStdout
    Private fStopThread As Boolean
    Private strINIFile As String
    Private str7ZIPFile As String
    Private lMode As Long

    Private Sub ExtCmdStdout_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
        fStopThread = True
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ExtCmdThreadStart(Me, Command)
    End Sub


    Public Sub ExtCmdThreadStart(ByRef Form As ExtCmdStdout, ByVal strCmdLine As String)
        Dim strWork As String
        Dim strCmdWork As String
        Dim lStrSet As Long
        Dim fErrParam As Boolean

        lMode = 0
        lStrSet = 0
        strINIFile = ""
        str7ZIPFile = ""
        fErrParam = False
        strCmdWork = strCmdline

        While (strCmdWork <> "")
            strWork = SplitParam(strCmdWork)
            If strWork = "-DMOV" Then
                lMode = 1
            ElseIf strWork = "-IZIP" Then
                lMode = 2
            ElseIf strWork = "-AZIP" Then
                lMode = 3
            ElseIf strWork = "-PING" Then
                lMode = 4
            ElseIf strWork = "-C" Then
                Me.chkEndClose.Checked = True
            ElseIf strWork = "" OrElse strWork.Substring(0, 1) <> "-" Then
                If lStrSet = 0 Then
                    strINIFile = strWork
                    lStrSet = 1
                ElseIf lStrSet = 1 Then
                    str7ZIPFile = strWork
                    lStrSet = 2
                Else
                    fErrParam = True
                End If
            End If
        End While

        If fErrParam OrElse lMode = 0 OrElse strINIFile = "" OrElse (lMode = 1 And str7ZIPFile = "") Then
            MsgBox("引数に誤りがあります" & vbCrLf & "「" & strCmdLine & "」", MsgBoxStyle.OkOnly, "警告")
            Me.Close()
            Exit Sub
        End If

        FormStdout = Form
        fStopThread = False
        Dim wkThread As New Thread(New ThreadStart(AddressOf ThreadMethod))
        wkThread.Start()
    End Sub

    Function SplitParam(ByRef strParam As String) As String
        Dim lIdxSP As Long
        Dim lIdxDQ As Long
        Dim lIdxDQ2 As Long

        ' 先頭の空白を削除
        strParam = strParam.TrimStart()
        lIdxSP = strParam.IndexOf(" ")
        lIdxDQ = strParam.IndexOf("""")
        If lIdxDQ = 0 Then
            ' "で始まる文字列
            lIdxDQ2 = strParam.Substring(1).IndexOf("""") + 1
            If lIdxDQ2 = -1 Then
                'で始まって"で終わっていない
                SplitParam = strParam.Substring(1)
                strParam = ""
            Else
                'で始まって"で終わる
                SplitParam = strParam.Substring(1, lIdxDQ2 - 1)
                strParam = strParam.Substring(lIdxDQ2 + 1)
            End If
        ElseIf lIdxSP = -1 Then
            ' "で始まっておらず空白を含まない
            SplitParam = strParam
            strParam = ""
        Else
            ' "で始まっておらず空白を含む
            SplitParam = strParam.Substring(0, lIdxSP)
            strParam = strParam.Substring(lIdxSP)
        End If
        SplitParam.TrimEnd()
    End Function

    Public Sub ThreadMethod()
        SetStatus("実行中")

        If lMode = 1 Then
            MoveSakushaFile()
        ElseIf lMode = 2 Or lMode = 3 Then
            CompressFolder()
        End If

        SetStatus("終了")
    End Sub

    Function MoveSakushaFile() As Boolean
        Dim strPath As String
        Dim strFileNum As String
        Dim strFile As String
        Dim strFolder As String
        Dim lNum As Long
        Dim lLoop As Long
        Dim lIdxSt As Long
        Dim lIdxEd As Long
        Dim fResult As Long
        Dim strResult As String
        Dim strNewPath As String
        Dim strOldPath As String

        strPath = GetINIString("ACTIVE", "Path", strINIFile)
        strFileNum = GetINIString("ACTIVE", "SelFileNum", strINIFile)
        AddList("☆ タグ毎にフォルダを作ってコピー処理")
        AddList("☆ PATH:" & strPath)
        AddList("☆ FolderNum:" & strFileNum)
        If strPath = "" Or strFileNum = "" Then
            MoveSakushaFile = False
            Exit Function
        End If

        lNum = Long.Parse(strFileNum)

        For lLoop = 1 To lNum
            ' フォルダ名取得
            strFile = GetINIString("ACTIVE", "SelFile" & lLoop, strINIFile)
            AddList("☆ Folder:" & strFile)

            lIdxSt = strFile.IndexOf("[")
            lIdxEd = -1
            If lIdxSt = -1 Then
                AddList("ファイル名中に[が存在しません。")
            Else
                lIdxEd = strFile.Substring(lIdxSt + 1).IndexOf("]") + lIdxSt + 1
                If lIdxEd = -1 Then
                    AddList("ファイル名中に]が存在しません。")
                End If
            End If

            ' コピー先ディレクトリ
            If lIdxSt <> -1 And lIdxEd <> -1 Then
                strFolder = strPath & strFile.Substring(lIdxSt + 1, lIdxEd - lIdxSt - 1)
            Else
                strFolder = ""
            End If

            fResult = CreateDirectory(strFolder, Nothing)
            If fResult Then
                strResult = "○"
            Else
                strResult = "×"
            End If

            strOldPath = strPath & strFile
            strNewPath = strFolder & "\" & strFile
            fResult = MoveFile(strOldPath, strNewPath)
            If fResult Then
                strResult = strResult & "○"
            Else
                strResult = strResult & "×"
            End If
            strResult = strResult & "File:" & strFile
            AddList(strResult)
            If fStopThread Then
                AddList("中断しました！")
                SetStatus("中断")
                Exit For
            End If
        Next
    End Function

    Delegate Function ReadLineAsyncDelegate() As String

    Function CompressFolder() As Boolean
        Dim strPath As String
        Dim strFolderNum As String
        Dim strFolder As String
        Dim lNum As Long
        Dim results As String
        Dim psi As New System.Diagnostics.ProcessStartInfo()
        Dim lLoop As Long
        Dim hStream As System.IO.FileStream
        Dim fError As Boolean

        strPath = GetINIString("ACTIVE", "Path", strINIFile)
        strFolderNum = GetINIString("ACTIVE", "SelFolderNum", strINIFile)
        AddList("☆ フォルダ毎にZIPに圧縮処理")
        AddList("☆ PATH:" & strPath)
        AddList("☆ FolderNum:" & strFolderNum)
        If strPath = "" Or strFolderNum = "" Then
            CompressFolder = False
            Exit Function
        End If

        lNum = Long.Parse(strFolderNum)

        For lLoop = 1 To lNum
            ' フォルダ名取得

            strFolder = GetINIString("ACTIVE", "SelFolder" & lLoop, strINIFile)
            AddList("☆ Folder" & lLoop & ":" & strFolder)

            If strFolder <> "." And strFolder <> ".." Then
                ' 圧縮処理
                'EXEのパスを取得する
                If lMode <> 4 Then
                    psi.FileName = str7ZIPFile
                Else
                    psi.FileName = "ping.exe"
                End If
                '出力を読み取れるようにする
                psi.RedirectStandardInput = False
                psi.RedirectStandardOutput = True
                psi.UseShellExecute = False
                'ウィンドウを表示しないようにする
                psi.CreateNoWindow = True
                'コマンドラインを指定（"/c"は実行後閉じるために必要）
                If lMode = 2 Then
                    psi.Arguments = " a -tzip -r " & _
                                    """" & strPath & strFolder & ".zip"" " & _
                                    """" & strPath & strFolder & "\*.jpg"" " & _
                                    """" & strPath & strFolder & "\*.gif"" " & _
                                    """" & strPath & strFolder & "\*.png"""
                ElseIf lMode = 3 Then
                    psi.Arguments = " a -tzip -r " & _
                                    """" & strPath & strFolder & ".zip"" " & _
                                    """" & strPath & strFolder & "\*.*"""
                ElseIf lMode = 4 Then
                    psi.Arguments = "-n 10 localhost"
                Else
                    AddList("パラメタエラー")
                    Exit Function
                End If

                '起動
                Dim p As System.Diagnostics.Process = System.Diagnostics.Process.Start(psi)
                '出力を読み取る
                fError = False

                Dim ar As IAsyncResult
                Dim strOutput As String
                Dim dlgt As New ReadLineAsyncDelegate(AddressOf p.StandardOutput.ReadLine)

                strOutput = ""
                ar = dlgt.BeginInvoke(Nothing, Nothing)
                While (True)
                    If fStopThread Then
                        On Error Resume Next
                        p.Kill()
                        AddList("☆ 中断しました！")
                        SetStatus("中断")
                        fError = True
                        Exit While
                    End If


                    If ar.IsCompleted = True Then
                        strOutput = dlgt.EndInvoke(ar)
                        If strOutput Is Nothing Then
                            'EOF
                            Exit While
                        Else
                            AddList(strOutput)
                        End If
                        ar = dlgt.BeginInvoke(Nothing, Nothing)
                    End If
                    Sleep(1)

                End While
                AddList("☆ 復帰コード:" & Format(p.ExitCode))
            End If

            If fStopThread Then
                Exit For
            End If
        Next
        AddList("☆ 処理終了")
        hStream = System.IO.File.Create(strPath & "Complete!!.txt")
        If Not hStream Is Nothing Then
            hStream.Close()
        End If
    End Function

    Private Sub AddList(ByVal [text] As String)
        If Me.Visible = False Then
            Exit Sub
        End If
        If Me.lstStdout.InvokeRequired Then
            Dim d As New AddListCallback(AddressOf AddList)
            Me.Invoke(d, New Object() {[text]})
        Else
            Dim lLineNum As Long = Me.lstStdout.Height / Me.lstStdout.ItemHeight
            Me.lstStdout.Items.Add([text])
            If Me.lstStdout.Items.Count - lLineNum > 0 Then
                Me.lstStdout.TopIndex = Me.lstStdout.Items.Count - lLineNum
            End If
        End If
    End Sub

    Private Sub SetStatus(ByVal [text] As String)
        If Me.lstStdout.InvokeRequired Then
            Dim d As New SetStatusCallback(AddressOf SetStatus)
            Me.Invoke(d, New Object() {[text]})
        Else
            Me.txtStatus.Text = [text]
        End If
    End Sub

    Private Sub txtStatus_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtStatus.TextChanged
        If Me.txtStatus.Text = "終了" Then
            btnStop.Text = "終了(&C)"
            If Me.chkEndClose.Checked Then
                Me.Close()
            End If
        End If
    End Sub

    Private Sub btnStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStop.Click
        If Me.txtStatus.Text = "実行中" Then
            If MsgBox("中断しますか？", MsgBoxStyle.YesNo, "確認") <> MsgBoxResult.Yes Then
                Exit Sub
            End If
            fStopThread = True
        Else
            Me.Close()
        End If
    End Sub

    Private Sub ExtCmdStdout_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        Dim cx As Long
        Dim cy As Long

        If Me.ClientSize.Width < 120 Then
            cx = 120
        Else
            cx = Me.ClientSize.Width
        End If
        If Me.ClientSize.Height < 120 Then
            cy = 120
        Else
            cy = Me.ClientSize.Height
        End If

        Me.lstStdout.Width = cx - (8 * 2)
        Me.lstStdout.Height = cy - (8 * 6)
        Me.btnStop.Top = cy - (8 * 4)
        Me.chkEndClose.Top = Me.btnStop.Top + 4
        Me.lblStatus.Top = Me.btnStop.Top + 4
        Me.txtStatus.Top = Me.btnStop.Top
    End Sub
End Class
